function [Wolves, Villagers, Hunter_mode] = Hunter_funk(Wolves, Villagers)
%% Hunters function
% function [Wolves, Villagers, Hunter_mode] = Hunter_funk(Wolves, Villagers)
% 
% The Hunter is a unique member of the Villagers who kills another random 
% Player when killed. It is twice as likely for a wolve to be killed. 
% 
% Input Arguments: 
%   
%   Wolves    -> Number of wolves [integer]
% 
%   Villagers -> Number of villagers [integer]
%
% Output Arguments:
%   
%   Wolves      -> Number of remaining wolves [integer]
% 
%   Villagers   -> Number of remaining villagers [integer]
%
%   Hunter_mode -> As a form of intrinsic inactivation the function sets 
%                  Hunter_mode on 0, to inactivate the character after
%                  it has been killed
%
%
% 13.09.2022

%%
Players_double = 2*Wolves + Villagers;     % Number of wolves is doubled as
       % disp('The victim was the hunter')  % to their probability of being 
                                           % killed
        second_victim = randi([1 Players_double]);
        if second_victim > 2*Wolves
            Villagers = Villagers - 1;
            %disp('Because of the Hunters Death a second Wolf has been killed!')
        else 
            Wolves = Wolves - 1;
            %disp('Because of the Hunters Death a Wolf has been killed!')
        end
Hunter_mode = 0;                           % Hunter inactivated
end